import sys
sys.path.append("antlr4_python3_runtime-4.7.2-py3.10.egg")
sys.path.append("pyttern-0.1.3-py3.10.egg")
from pyttern.matcher import match_files, match_wildcards



def process_code_files():
    """
    Process code files and generate a CSV file with the results.

    This function matches wildcard patterns to find code files in the './pyttern/' directory
    and test files in the './code/' directory. It then generates a CSV file named 'result.csv'
    with the column names and corresponding values for each file and test.
    """

    # Keep track of info for csv
    column_names = ["code"]
    lines = []

    # Match all wildcards on all code.
    # This can be change either by changing the wildcards or by using
    # the method `match_files` instead.
    result = match_wildcards("./pyttern/*", "./code/code*.py", n_threads=1)
    for file in result:                     # Go through all the results
        line = [file]                       # Keep track for csv
        for test in result[file]:
            # Save column name
            if test not in column_names:
                column_names.append(test)   
            
            # Save result
            res = result[file][test]
            line.append(str(res))

        lines.append(";".join(line))
    
    columns = ";".join(column_names)
    values = "\n".join(lines)

    # Save result in csv
    with open("result.csv", "w") as csv:
        csv.write(columns + "\n")
        csv.write(values)
        

process_code_files()
