Experience source file for analysing the AST of Python programs using Pyttern.

## Installation
Everything should be inside this directory. !Do not try to install it using pip! To have a small output during the execution of the matching, you can install [tqdm](https://pypi.org/project/tqdm/).
You should have at least Python 3.10.

## Quick start
The small documentation on pyttern can be found in the file [pyttern_readme](pyttern_readme.md).

Create a new Python file called `flaw_1.pyt` in `pyttern/` directory.
The file should contains the pyttern code to match the flaw.

## Structure
### File structure
Keep the structure simple.

```
code/
pyttern/
    flaw_1.pyt
    ...
    flaw_n.pyt
detect_flaws.py
readme.md
result.csv
antlr4_python3_runtime-4.7.2-py3.10.egg
pyttern-0.1.2-py3.10.egg
```

You can change the structure of the pyttern subdirectory. For example, you can create subdirectory per flaws that you detect. This allows you to create multiple pattern to detect a flaw.

### CSV structure
Please keep the structure of the output csv file.
```
code;flaw_1;flaw_2;...;flaw_n
code1;True;False;...;False
...
coden;False;True;...;False
```

### [detect_flaws.py](detect_flaws.py) structure
You can change this file as you want. But as said before, please keep the same output format in the csv.
The matcher can be slow. Don't hesitate to test your Pytterns on a subset of the given code. 

## Result
At the end, please provide all the content of this folder. Even unfinished code will be useful! All the code is anonymous.